package my.petstore.entity;

import java.util.Collections;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.Table;


@Entity
@Table(name = "categories")
public class Category extends NamedEntity {

    @Column(name = "image_path")
    private String imagePath;

    @OneToMany(mappedBy = "category", fetch = FetchType.EAGER)
    private Set<Product> products;

    public String getImagePath() { return imagePath; }
    public void setImagePath(String imagePath) { this.imagePath = imagePath; }

    public Set<Product> getProducts() { return products; }
    public void setProducts(Set<Product> products) { this.products = products; }

    public static final Category NULL = new Category() {
        {
            setImagePath("");
            setProducts(Collections.<Product>emptySet());
        }
    };
}
