package my.petstore.entity;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name = "items")
public class Item extends BaseEntity {

    private int listPrice;
    private int unitCost;
    private String status;
    private String attribute;
    
    @ManyToOne(cascade = CascadeType.ALL)
    private Product product;
    
    @OneToOne(mappedBy = "item", fetch = FetchType.EAGER)
    private Inventory inventory;

    public int getListPrice() { return listPrice; }
    public void setListPrice(int listPrice) { this.listPrice = listPrice; }

    public int getUnitCost() { return unitCost; }
    public void setUnitCost(int unitCost) { this.unitCost = unitCost; }

    public String getStatus() { return status; }
    public void setStatus(String status) { this.status = status; }

    public String getAttribute() { return attribute; }
    public void setAttribute(String attribute) { this.attribute = attribute; }

    public Inventory getInventory() { return inventory; }
    public void setInventory(Inventory inventory) { this.inventory = inventory; }

    public Product getProduct() { return product; }
    public void setProduct(Product product) { this.product = product; }

    @Override
    public String toString() {
        return "(" + getId() + "-" + getProduct().getId() + ")";
    }

    public static final Item NULL = new Item() {
        {
            setStatus("");
            setAttribute("");
            setInventory(Inventory.NULL);
            setProduct(Product.NULL);
        }
    };
}
