package my.petstore.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name = "lineitems")
public class LineItem extends BaseEntity {
    @Column(name = "linenum")
    private int lineNumber;
    private int quantity;
    private int unitPrice;

    @OneToOne
    @JoinColumn(name = "item_id")
    private Item item;

    public LineItem(int lineNumber, CartItem cartItem) {
        this.lineNumber = lineNumber;
        this.quantity = cartItem.getQuantity();
        this.item = cartItem.getItem();
        this.unitPrice = cartItem.getItem().getListPrice();
    }
    public LineItem() {
    }

    public int getLineNumber() {
        return lineNumber;
    }
    public void setLineNumber(int lineNumber) {
        this.lineNumber = lineNumber;
    }

    public int getQuantity() {
        return quantity;
    }
    public void setQuantity(int quantity) {
        this.quantity = quantity;
    }

    public int getUnitPrice() {
        return unitPrice;
    }
    public void setUnitPrice(int unitprice) {
        this.unitPrice = unitprice;
    }

    public Item getItem() {
        return item;
    }
    public void setItem(Item item) {
        this.item = item;
    }

    public int getTotalPrice() {
        return this.unitPrice * this.quantity;
    }

}
