// I think this layer's unittest is not more effective than service layer's unittest.
// I keep this code just for your information.

package my.petstore.entity;

import static org.junit.Assert.assertThat;
import static org.hamcrest.Matchers.*;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.transaction.annotation.Transactional;

@ContextConfiguration(locations = {"classpath:spring/applicationContext-jpa.xml"})
@RunWith(SpringJUnit4ClassRunner.class)
public class OrderDataTest {

    @PersistenceContext
    private EntityManager em;

    @Test
    @Transactional
    public void storeOrderData() {
        Cart cart = new Cart();
        cart.addItem(em.find(Item.class, 1), true);
        cart.addItem(em.find(Item.class, 2), true);

        OrderData orderData = new OrderData(cart);
        orderData.setShipToName("foo");
        orderData.setShipAddress("bar");
        
        orderData = em.merge(orderData);

        em.flush();
        assertThat(orderData.getId(), notNullValue());

        em.clear();

        int id = orderData.getId();
        OrderData orderData2 = em.find(OrderData.class, id);
        assertThat(orderData2.getLineItems().size(), is(2));
    }
}

