package my.petstore.service;

import static org.junit.Assert.assertThat;
import static org.hamcrest.Matchers.*;

import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import my.petstore.entity.Product;
import my.petstore.entity.Item;
import my.petstore.entity.OrderData;

@ContextConfiguration(locations = {"classpath:spring/applicationContext-jpa.xml"})
@RunWith(SpringJUnit4ClassRunner.class)
public class ProductSearchTest {

    @Autowired
    protected ProductService productService;

    @Test
    public void searchNull() {
        List<Product> result = productService.searchProductList(null);
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(true));
    }

    @Test
    public void searchEmpty() {
        List<Product> result = productService.searchProductList("");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(true));
    }

    @Test
    public void searchOneChar() {
        List<Product> result = productService.searchProductList("a");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(false));
    }

    @Test
    public void searchSpecialChar() {
        List<Product> result = productService.searchProductList("%");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(false));

        result = productService.searchProductList("%%");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(false));

        result = productService.searchProductList("_");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(false));

        result = productService.searchProductList("__");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(false));

        result = productService.searchProductList("'");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(true));

        result = productService.searchProductList("\"");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(true));

        result = productService.searchProductList("\\");
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(true));
    }
}
